//writeln by Kunack, rud69@bk.ru
//    ,    ,   .
//====================      -      ======================
//       ()(   ,  ,   google) 
//       ,      
//(   ,    ),   ,         .
//,   ,    -       . 
// ,               .
//  ,        " "   ,  ,
//:    -         .   .
// ,     ,         .
//
//   ,       (  ).
//
//            iCustom     .
//     ,       " "     
//"Three_Candles_Line_Up"     "Three_Candles_Line_Down"  .
//         .    , ,   
//" " = ObjectGet("Three_Candles_Line_Up", OBJPROP_PRICE2).
//   .
#property indicator_chart_window

extern int find_bars = 10;          //    ,    
                                    //      .    ,
                                    //   .
extern int width = 3;               // .
extern color col_up = DarkOrange;   //   .
extern color col_down = DodgerBlue;

int bars;
int b_low1, b_low2, b_low3, b_high1, b_high2, b_high3, up_bar, down_bar;
double low1, low2, low3, high1, high2, high3;
int init() {
   bars = 0;
   return (0);
}
int deinit(){
   ObjectDelete("Three_Candles_Line_Up");
   ObjectDelete("Three_Candles_Line_Down");
   return (0);
}
int start()
  {
   if (bars == Bars) return;
   bars = Bars;
   Draw_Three_Candles_Line_Up();
   Draw_Three_Candles_Line_Down();
   return(0);
  }
//-----------------------------------------------------------------------------------------------------
void Draw_Three_Candles_Line_Up(){

   for(int i = 1; i < 100; i++){
      if (iFractals( NULL, 0, MODE_UPPER, i) == 0) continue;
      b_low1 = i;
      low1 = Low[b_low1];
      b_low2 = FindNextLow(b_low1 + 1, low1);
      if (b_low2 == 0) continue;
      low2 = Low[b_low2];
      b_low3 = FindNextLow(b_low2 + 1, low2);
      if (b_low3 == 0) continue;
      low3 = Low[b_low3];
      break;
   }
   Draw_Line("Three_Candles_Line_Up", Time[b_low1], High[b_low1], Time[b_low3], low3, width, col_up);
   return;
}
//-----------------------------------------------------------------------------------------------------
void Draw_Three_Candles_Line_Down(){
   for(int i = 1; i < 100; i++){
      if (iFractals( NULL, 0, MODE_LOWER, i) == 0) continue;
      b_high1 = i;
      high1 = High[b_high1];
      b_high2 = FindNextHigh(b_high1 + 1, high1);
      if (b_high2 == 0) continue;
      high2 = High[b_high2];
      b_high3 = FindNextHigh(b_high2 + 1, high2);
      if (b_high3 == 0) continue;
      high3 = High[b_high3];
      break;
   }
   Draw_Line("Three_Candles_Line_Down", Time[b_high1], Low[b_high1], Time[b_high3], high3, width, col_down);
   return;
}
//-----------------------------------------------------------------------------------------------------
void Draw_Line(string name, datetime date1, double price1, datetime date2, double price2, int width, color col){
   if (ObjectFind(name) == -1){
      ObjectCreate(name,OBJ_FIBO, 0, date1, price1, date2, price2);
      ObjectSet(name, OBJPROP_COLOR, Red);
      ObjectSet(name, OBJPROP_RAY, false);
      ObjectSet(name, OBJPROP_BACK, true);
      ObjectSet(name, OBJPROP_LEVELSTYLE, STYLE_SOLID); 
      ObjectSet(name, OBJPROP_LEVELWIDTH, width);  
      ObjectSet(name, OBJPROP_LEVELCOLOR, col);
      ObjectSet(name, OBJPROP_FIBOLEVELS, 1);
      ObjectSet(name, OBJPROP_FIRSTLEVEL+0, 0);
      ObjectSetFiboDescription(name,0,"%$       ");
   }
   else{
      ObjectMove(name,0,date1, price1);
      ObjectMove(name,1,date2, price2);
    }
   return;
}

//-----------------------------------------------------------------------------------------------------
int FindNextLow(int start, double low){
   for(int i = start; i < start + find_bars; i++){
      if (Low[i] < low) return (i);
   }
   return (0);
}
//-----------------------------------------------------------------------------------------------------
int FindNextHigh(int start, double high){
   for(int i = start; i < start + find_bars; i++){
      if (High[i] > high) return (i);
   }
   return (0);
}
//-----------------------------------------------------------------------------------------------------

